//
// user config (change here)
//
var DEFAULT_KEYWORD = 'まなめ';
var BLOGSEARCH_MAX = 2;
var RSS_URL = new Array(BLOGSEARCH_MAX);

var MAX_ITEMS = 20;

// value are "sec"
var ERROR_RELOAD_TIMER = 60;     // retry RSS GET
var RSS_TIMEOUT = 10;            // RSS GET timeout
var NORMAL_RELOAD_TIMER = 10*60; // RSS refresh interval

//
// enums
//
var MODE_NORMAL = 0;
var MODE_FOCUS  = 1;
var MODE_ACTIVE = 2;
var STATE_INIT    = 0;
var STATE_LOADING = 1;
var STATE_SUCCESS = 2;
var STATE_ERROR   = 3;

var nodeBase      = getNode("base");
var nodeBgImage   = getChildNode(nodeBase, "bgimage");
var nodeTitle     = getChildNode(nodeBase, "blogtitle");
var nodeArrowUp   = getChildNode(nodeBase, "arrowup");
var nodeArrowDown = getChildNode(nodeBase, "arrowdown");

var nodeActive    = getNode("active");
var nodeActiveBg  = getChildNode(nodeActive, "activebgimage");

var nodeBlogEntryTitle = getChildNode(nodeActive, "blogentrytitle");
var nodeBlogEntryDesc  = getChildNode(nodeActive, "blogentrydesc");
var nodeActiveButton   = getChildNode(nodeActive, "button");

var nodeSiteLogo   = getChildNode(nodeBase, "sitelogo");
var nodeErrMsg     = getChildNode(nodeBase, "errorMsg");
var nodeLoadingMsg = getChildNode(nodeBase, "loadingMsg");

//
// 0:normal, 1:focus, 2:active
//
var mode = MODE_NORMAL;

//
// 0:init, 1:loading, 2:success, 3:error
//
var state = STATE_INIT;
var errorStr = null;

//
//
var MAX_ITEMS_IN_WINDOW = 5;
var nodeBlogItem = new Array(MAX_ITEMS_IN_WINDOW);
var nodeFocusBar = new Array(MAX_ITEMS_IN_WINDOW);

var nItems = 0;

var rsstitle = "";
var titlelist = new Array(MAX_ITEMS);
var linklist  = new Array(MAX_ITEMS);
var desclist  = new Array(MAX_ITEMS);

var selectedItem = 0; // selected blog entry
var cursorPos = 0;    // cursor position
var windowHead = 0;   // item number of first item in window

var xmlhttp = null;
var httpTimeoutId;

function onLoad() {
  setRGB(nodeTitle, '000000');
  setRGB(nodeErrMsg, '000000');
  setRGB(nodeLoadingMsg, '000000');

  var i;
  for (i = 0; i < MAX_ITEMS_IN_WINDOW; i++) {
    nodeFocusBar[i] = getChildNode(nodeBase, "sel" + i);
    nodeBlogItem[i] = getChildNode(nodeBase, "item" + i);
  }

  setRGB(nodeBlogEntryTitle, '000000');
  setRGB(nodeBlogEntryDesc, '000000');

  loadImage(nodeBgImage, "./parts/normal.png");
  loadImage(nodeSiteLogo, "./parts/site-logo.png");

  RSS_URL[0] = 'http://blog-search.yahoo.co.jp/rss?ei=UTF-8&p=';
  RSS_URL[1] = 'http://feeds.technorati.jp/search/';

  doHttpRequest();
}

function onUpKey() {
  print("onUpKey\n");

  if (mode == MODE_ACTIVE) {
    return;
  }

  if (nItems <= 0) {
    return;
  }

  if (selectedItem > 0) {
    selectedItem--;
  } else {
    return;
  }

  if (cursorPos == 0) {
    windowHead--;
  } else {
    cursorPos--;
  }

  refreshFocusMode();
}

function onDownKey() {
  print("onDownKey\n");

  if (mode == MODE_ACTIVE) {
    return;
  }

  if (nItems <= 0) {
    return;
  }

  if (selectedItem < nItems - 1) {
    selectedItem++;
  } else {
    return;
  }

  if (cursorPos < MAX_ITEMS_IN_WINDOW - 1) {
    cursorPos++;
  } else {
    windowHead++;
  }

  refreshFocusMode();
}

function onRightKey() {
}

function onLeftKey() {
}

function onConfirmKey(type) {
  if (type == 1) {
    return;
  }

  if (selectedItem < 0) {
    return;
  }
  if (!linklist[selectedItem]) {
    return;
  }

  execBrowser(linklist[selectedItem]);
}

function onFocus() {
  mode = MODE_FOCUS;

  refreshFocusMode();
}

function onUnfocus() {
  mode = MODE_NORMAL;

  refreshNormalMode();

  setVisible(nodeBase, 1);
  setVisible(nodeActive, 0);
}

function onActivate() {
  mode = MODE_ACTIVE;

  loadImage(nodeActiveBg, "./parts/active.png");

  if (state == STATE_SUCCESS) {
    loadImage(nodeActiveButton, "./parts/execBrowserButton.png");
  }

  setVisible(nodeBase, 0);
  setVisible(nodeActive, 1);

  refreshActiveMode();
}

////

function onReadyStateError() {
  if (mode == MODE_NORMAL) {
    refreshNormalMode();
  } else if (mode == MODE_FOCUS) {
    refreshFocusMode();
  }
}

function onReadyStateChangeCallback() {
  print("onreadystatechange " + xmlhttp.readyState + "\n");

  if (xmlhttp.readyState != 4) {
    print("readyState = " + xmlhttp.readyState + "\n");
    return;
  }
  if (xmlhttp.status != 200) {
    if (xmlhttp.status != 0) {
      print("ERROR : HTTP status " + xmlhttp.status + "\n");
      state = STATE_ERROR;
      errorStr = "HTTP status : " + xmlhttp.status;
    }
    onReadyStateError();
    return;
  }

  // clear timeout timer
  clearTimeout(httpTimeoutId);

  if (parseRss(xmlhttp.responseXML) != 0) {
    print("ERROR : parseRss failed\n");
    state = STATE_ERROR;
    errorStr = "RSS parse failed";
    onReadyStateError();
    return;
  }

  state = STATE_SUCCESS;

  if (mode == MODE_NORMAL) {
    refreshNormalMode();
  } else if (mode == MODE_FOCUS) {
    refreshFocusMode();
  }

  setTimeout(doHttpRequest, NORMAL_RELOAD_TIMER*1000);
}

function httpTimeout() {
  print("httpTimeout\n");

  // abort() will trigger error with HTTP status 0
  xmlhttp.abort();
  state = STATE_ERROR;
  errorStr = "RSS GET timedout";

  // schedule next RSS GET
  if (setTimeout(doHttpRequest, ERROR_RELOAD_TIMER*1000) == null) {
    print("setTimeout == null\n");
  }
}

function doHttpRequest() {
  print("doHttpRequest()\n");

  var keyword = getStoredValue("Item1");
  var servicetype = getStoredValue("Item2");
  if (keyword == null) {
    keyword = DEFAULT_KEYWORD;
  }
  if (servicetype == null) {
    servicetype = 1;
  }

  var rssurl;

  keyword = escape(keyword);
  if (servicetype <= BLOGSEARCH_MAX && servicetype > 0) {
    rssurl = RSS_URL[servicetype - 1] + keyword;
  } else {
    print("error 0 : %d\n", servicetype);
    state = STATE_ERROR;
    errorStr = "Invalid Configuration";
    return;
  }

  print(rssurl);

  state = STATE_LOADING;

  httpTimeoutId = setTimeout(httpTimeout, RSS_TIMEOUT*1000);
  if (httpTimeoutId == null) {
    print("setTimeout == null (2)\n");
  }

  xmlhttp = new XMLHttpRequest();
  if (!xmlhttp) {
    print("error 1\n");
    state = STATE_ERROR;
    errorStr = "internal error";
    return;
  }

  xmlhttp.onreadystatechange = onReadyStateChangeCallback;
  xmlhttp.open('GET', rssurl);
  xmlhttp.send(null);
}

function parseRss(xml) {
  print("parseRss()\n");

  var channel = xml.getElementsByTagName("channel");
  if (!channel) {
    print("error !channel\n");
    return -1;
  }

  var rsstitleobj = channel[0].getElementsByTagName("title");
  if (!rsstitleobj) {
    print("error !title\n");
    return -1;
  }

  rsstitle = rsstitleobj[0].firstChild.nodeValue;

  var items = xml.getElementsByTagName("item");
  if (!items) {
    print("error !items\n");
    return -1;
  }

  var i = 0;
  nItems = 0;
  for (i = 0; i < items.length; i++) {
    if (i >= MAX_ITEMS) {
      break;
    }

    var titleobj = items[i].getElementsByTagName("title");
    if (!titleobj) {
      continue;
    }
    var linkobj  = items[i].getElementsByTagName("link");
    if (!linkobj) {
      continue;
    }

    if (!titleobj[0] || !titleobj[0].firstChild ||
        !linkobj[0] || !linkobj[0].firstChild) {
      continue;
    }

    titlelist[i] = titleobj[0].firstChild.nodeValue;
    linklist[i]  = linkobj[0].firstChild.nodeValue;

    var descobj  = items[i].getElementsByTagName("description");
    if (descobj) {
      if (descobj[0] && descobj[0].firstChild) {
        desclist[i]  = descobj[0].firstChild.nodeValue;
      }
    }

    nItems++;
  }

  return 0;
}

function refreshBase() {
  if (state != STATE_LOADING) {
    setVisible(nodeLoadingMsg, 0);
  } else {
    setVisible(nodeLoadingMsg, 1);
  }

  if (state != STATE_SUCCESS) {
    setVisible(nodeSiteLogo, 1);

    if (state == STATE_ERROR) {
      if (errorStr) {
        setStr(nodeErrMsg, "ERROR : " + errorStr);
      }
    }

    return -1;
  }

  // hide site logo, it should be shown only on load or error state
  setVisible(nodeSiteLogo, 0);

  if (rsstitle) {
    setStr(nodeTitle, rsstitle);
  }

  return 0;
}

function refreshNormalMode() {
  if (refreshBase() != 0) {
    return;
  }

  var i;
  for (i = 0; i < MAX_ITEMS_IN_WINDOW; i++) {
    setRGB(nodeBlogItem[i], "333333");
    setStr(nodeBlogItem[i], titlelist[windowHead+i]);
  }
}

function refreshFocusMode() {
  if (refreshBase() != 0) {
    return;
  }

  var i;
  for (i = 0; i < MAX_ITEMS_IN_WINDOW; i++) {
    if (i == cursorPos) {
      loadImage(nodeFocusBar[i], "./parts/selected.png");
      setRGB(nodeBlogItem[i], "666666");
    } else {
      setRGB(nodeBlogItem[i], "000000");
      destroyImage(nodeFocusBar[i]);
    }

    setStr(nodeBlogItem[i], titlelist[windowHead+i]);
  }

  if (windowHead != 0) {
    loadImage(nodeArrowUp, "./parts/arrow-up.png");
  } else {
    destroyImage(nodeArrowUp);
  }

  if (windowHead + MAX_ITEMS_IN_WINDOW >= nItems) {
    destroyImage(nodeArrowDown);
  } else {
    loadImage(nodeArrowDown, "./parts/arrow-down.png");
  }
}

function refreshActiveMode() {
  if (state != STATE_SUCCESS) {
    setStr(nodeBlogEntryTitle, "ERROR");
    setStr(nodeBlogEntryDesc, errorStr);
    return;
  }

  if (selectedItem < 0) {
    return;
  }

  setStr(nodeBlogEntryTitle, titlelist[selectedItem]);
  if (desclist[selectedItem]) {
    setStr(nodeBlogEntryDesc, desclist[selectedItem]);
  }
}
